using System;
using System.Data;
using System.Globalization;
using System.Resources;
using System.Threading;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using DevExpress.Web;
/****************************************************************************************************************************
* Project Name    : TimeCheck                                              Started Date  : 12-Aug-2007
* Module          : Generic Master                                         Last Modified : 21-Aug-2007
* Programmer      : Arun Vinoth.T
* Current Storage : \\Angler56\Projects\Inprogress\SCREEN1206\code\Time_AttendanceApp
* BackUp          :
****************************************************************************************************************************/
public partial class Masters_TA_UI_Master_CountryList : Base.BasePage
{
    #region "variable Declaration"
    ResourceManager rm;
    CultureInfo ci;
    GenericEventdata objGeneric = new GenericEventdata();
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    cls_Common objcommon = new cls_Common();
    string gstrUserGroupName = string.Empty;
    int auEmpId;
    string source_Language;
    LeaveEventData objLeave = new LeaveEventData();
    string strScript = string.Empty;
    #endregion
    #region PageLoad
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        base.Page_Load(sender, e);
        grv_country.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "RestoreAlert('" + rm.GetString("Alert_Norecordsfound", ci) + "','" + rm.GetString("Alert_Areyousuretorestore", ci) + "','" + rm.GetString("Alert_Selecteddataisnotindeletedstatus", ci) + "','" + rm.GetString("Alert_Selectdatatorestore", ci) + "','" + rm.GetString("Alert_Nodeletedrecordsavailable", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("RestoreAlert", strSetAlert);
        auEmpId = Convert.ToInt32(Session["EmpAutoID"].ToString());
        //Set UserRights
        UserRights();
        gstrUserGroupName = Convert.ToString(Session["UserGroupName"]);
        if (gstrUserGroupName == "SuperAdmin")
        {
            btn_Restore.Visible = false;
            btn_PermanentDelete.Visible = true;
            //grv_country.Columns[3].Visible = false;
        }
        else
        {
            btn_Restore.Visible = false;
            btn_PermanentDelete.Visible = false;
            //grv_country.Columns[3].Visible = false;
        }
        btn_add.Focus();
        if (!IsPostBack)
        {
            objcommon.menu("EmployeeMaster", "225");
        }
    }
    #endregion
    #region ButtonEvents
    protected void btn_add_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Master_CountryAdd.aspx");
    }
    protected void btn_Delete_Click(object sender, EventArgs e)
    {
        if (hdnSelectRow.Value != string.Empty && hdnSelectRow.Value != null)
        {
            objGeneric.TemporaryDelete_lookupdata(hdnSelectRow.Value, auEmpId);
            string str = "alert('" + rm.GetString("Alert_Countrydeletedsuccessfully", ci) + "');location.replace('TA_UI_Master_CountryList.aspx');";
            Page.ClientScript.RegisterStartupScript(this.GetType(), "alertBox", str, true);
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("DeletionRecordAlert", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }
    protected void btn_Cancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Masters_Generic_List.aspx");
    }
    //Getting Information from resource file and display it in label
    protected void btn_PermanentDelete_Click(object sender, EventArgs e)
    {
        if (hdnSelectRow.Value != string.Empty && hdnSelectRow.Value != null)
        {
            objGeneric.PermanentDelete_lookupdata(hdnSelectRow.Value, auEmpId);
            string str = "alert('" + rm.GetString("Alert_Countrydeletedsuccessfully", ci) + "');location.replace('TA_UI_Master_CountryList.aspx');";
            Page.ClientScript.RegisterStartupScript(this.GetType(), "alertBox", str, true);
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("DeletionRecordAlert", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }
    protected void btn_Restore_Click(object sender, EventArgs e)
    {
        string[] ChkBoxIDs;
        if (hdnSelectRow.Value != string.Empty && hdnSelectRow.Value != null)
        {
            ChkBoxIDs = objLeave.commaStringToArray(hdnSelectRow.Value);
            for (int i = 0; i < ChkBoxIDs.Length; i++)
            {
                DataSet LookupId = objGeneric.GetCityDetails(Convert.ToInt32(ChkBoxIDs[i]), "N");
                string Country = LookupId.Tables[0].Rows[0]["country"].ToString();
                int Count = objGeneric.CheckCountryInsertUpdate("M", Convert.ToInt32(ChkBoxIDs[i]), Country);
                if (Count > 0)
                {
                    base.Message(rm.GetString("Message_Cannot_Restore", ci));
                    BindGrid();
                    hdnSelectRow.Value = "";
                    return;
                }
            }
            objGeneric.Restore_lookupdata(hdnSelectRow.Value, auEmpId);
            base.MessageWithRedirect(rm.GetString("Alert_Countryrestoredsuccessfully", ci), "TA_UI_Master_CountryList.aspx");
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("DeletionRecordAlert", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }
    #endregion
    #region userDefinedFunctions
    private void LoadStrings(CultureInfo ci)
    {
        lbl_HeaderCountry.Text = rm.GetString("Masters_Generic_Country", ci);
        btn_add.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Add", ci);
        btn_Delete.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Delete", ci);
        btn_Cancel.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        btn_PermanentDelete.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Delete", ci);
        btn_Restore.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Restore", ci);
        grv_country.Columns[2].Caption = rm.GetString("Country_Name", ci);
        lblDataView.Text = rm.GetString("lblDataView", ci);

        //grv_country.Columns[3].Caption = rm.GetString("DeleteStatus", ci);
    }
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(225, Convert.ToInt32(Session["userGroup_Id"]), "");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["addPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["addPrv"]) == 1)
            {
                this.btn_add.Visible = true;
            }
            else
            {
                this.btn_add.Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["deletePrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["deletePrv"]) == 1)
            {
                this.btn_Delete.Visible = false;
                this.btn_PermanentDelete.Visible = true;
                this.btn_Restore.Visible = false;
                this.grv_country.Columns[0].Visible = true;
                this.grv_country.Columns[5].Visible = true;
            }
            else
            {
                this.btn_Delete.Visible = false;
                this.btn_PermanentDelete.Visible = false;
                this.btn_Restore.Visible = false;
                this.grv_country.Columns[0].Visible = false;
                this.grv_country.Columns[5].Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["modifyPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["modifyPrv"]) == 1)
            {
                this.grv_country.Columns[4].Visible = true;
            }
            else
            {
                this.grv_country.Columns[4].Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 1)
            {
                this.grv_country.Columns[3].Visible = true;
            }
            else
            {
                this.grv_country.Columns[3].Visible = false;
            }
        }
        else
        {
            Response.Redirect("MasterLandingPage.aspx");
        }
    }
    protected void BindGrid()
    {
        grv_country.DataBind();
    }
    #endregion
    #region GridveiwEvents
    protected void grv_country_HtmlRowCreated(object sender, DevExpress.Web.ASPxGridViewTableRowEventArgs e)
    {
        if (e.RowType == GridViewRowType.Data)
        {
            source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
            rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
            ci = Thread.CurrentThread.CurrentCulture;
            Label DeletedRecord = (Label)grv_country.FindRowCellTemplateControl(e.VisibleIndex, null, "lblIsDeleted");
            if (DeletedRecord != null)
            {
                if (DeletedRecord.Text == "True" || DeletedRecord.Text == rm.GetString("Grid_True", ci))
                {
                    DeletedRecord.ForeColor = System.Drawing.Color.Red;
                }
            }
            HtmlInputCheckBox deleteChkBxItem = (HtmlInputCheckBox)grv_country.FindRowCellTemplateControl(e.VisibleIndex, null, "chkSelect");
            LinkButton LnkbtnDelete = (LinkButton)grv_country.FindRowCellTemplateControl(e.VisibleIndex, null, "btnDelete");

            if (deleteChkBxItem != null)
            {
                int Lookup = Convert.ToInt16(e.GetValue("ID"));
                int Count = objGeneric.CountLookup(Lookup);
                if (Count > 0)
                {
                    deleteChkBxItem.Disabled = true;
                    LnkbtnDelete.Enabled = false;
                    LnkbtnDelete.OnClientClick = null;
                }
                else
                {
                    deleteChkBxItem.Disabled = false;
                    LnkbtnDelete.Enabled = true;
                }
            }
            if (DeletedRecord != null)
            {
                if (DeletedRecord.Text == "True")
                {
                    DeletedRecord.Text = rm.GetString("Grid_True", ci);
                    if (hdnDeletedData.Value == string.Empty)
                    {
                        hdnDeletedData.Value = e.GetValue("ID").ToString();
                    }
                    else
                    {
                        if (hdnDeletedData.Value.Contains(e.GetValue("ID").ToString()) == false)
                        {
                            hdnDeletedData.Value = hdnDeletedData.Value + "," + e.GetValue("ID").ToString();
                        }
                    }
                }
                else if (DeletedRecord.Text == "False")
                {
                    DeletedRecord.Text = rm.GetString("Grid_False", ci);
                }
            }
        }
    }
    #endregion
    //Todo:need to add below two button events
    protected void EditLinkButton_Click(object sender, EventArgs e)
    {
        LinkButton btn = sender as LinkButton;
        int Id = Convert.ToInt32(btn.CommandName);
        Response.Redirect("TA_UI_Master_CountryModify.aspx?Id=" + Id);
        //TOdo: Karthikeyan
    }
    protected void btn_delete_Click_1(object sender, EventArgs e)
    {
        //Todo: Karthikeyan Add
        LinkButton btn = sender as LinkButton;
        int LookupId = Convert.ToInt32(btn.CommandName);
        int Count = objGeneric.CountLookup(LookupId);
        if (Count > 0)
        {
            base.Message(rm.GetString("Master_Country_Cannot_Delete", ci));
            return;
        }
        else
        {
            objGeneric.PermanentDelete_lookupdata(LookupId.ToString(), auEmpId);
            base.MessageWithRedirect(rm.GetString("Alert_Countrydeletedsuccessfully", ci), "TA_UI_Master_CountryList.aspx");
        }
    }
}